if($Pref::HealthBar::ShowNumbers $= ""){
	$Pref::HealthBar::ShowNumbers = 1;}
	
$healthBarToggleTemp = $Pref::HealthBar::ShowNumbers;

new GuiControlProfile (HUDHealthbarTextProfile : BlockChatChannelSize0Profile)
{
	fontSize = 14;
	fontType = "Arial";
};

exec("./HealthBar.gui");

PlayGUI.add(HUD_HealthBarContainer);
HUD_HealthBar.setVisible(false);
HUD_HealthBarVehicle.setVisible(false);


function clientCmdDetectHealthBarMod()
{
	commandToServer('RegisterHealthBarMod');
}

function clientCmdDetectHealthBarVehicleMod()
{
	commandToServer('RegisterHealthBarVehicleMod');
}

//Client command that triggers the HP bar to be adjusted..
function clientCmdSetDamageLevel(%percent, %str)
{
	HUD_HealthBar.setHealthLevel(%percent, %str);
}

function clientCmdSetVehicleDamageLevel(%percent, %str)
{
	HUD_HealthBarVehicle.setHealthLevel(%percent, %str);
}

function clientCmdSetHealthBarVisible(%bool)
{
	HUD_HealthBar.setVisible(%bool);
	HUD_HealthBarTextHP.setVisible(%bool);
}

function clientCmdSetHealthBarVehicleVisible(%bool)
{
	HUD_HealthBarVehicle.setVisible(%bool);
	HUD_HealthBarVehicleTextHP.setVisible(bool);
}

function HUD_HealthBar::setHealthLevel(%gui, %dmgPer, %healthStr)
{
	//The client command takes the amount of damage.
	//We want to show the amount of health, so we need to invert the number.
	%percent = 1 - %dmgPer;
	
	if(%percent > 0)
	{
		%newPercent = %percent * 100;
		
		if(%healthStr $= "")
		{
			HUD_HealthBarTextHP.setVisible($Pref::HealthBar::ShowNumbers);
			HUD_HealthBarTextHP.setText("<just:center>" @ mFloor(%newPercent) @ "%");
		}
		else
		{
			if(%healthStr $= "I")
			{
				HUD_HealthBarTextHP.setText("<just:center>INVINCIBLE");
				HUD_HealthBarTextHP.setVisible($Pref::HealthBar::ShowNumbers);
			}
			else
			{
				HUD_HealthBarTextHP.setVisible($Pref::HealthBar::ShowNumbers);
				HUD_HealthBarTextHP.setText("<just:center>" @ mFloor(firstWord(%healthStr)) SPC "/" SPC mFloor(getWord(%healthStr, 1)));
			}
		}

		HUD_HealthMeter.setPercent(%newPercent, (%healthStr $= "I"));
	}

	else
	{
		//As does the energy bar, if you are killed the bar goes away.
		%gui.setVisible(false);
		HUD_HealthBarTextHP.setVisible(false);
	}
}

function HUD_HealthBarVehicle::setHealthLevel(%gui, %dmgPer, %healthStr)
{
	//The client command takes the amount of damage.
	//We want to show the amount of health, so we need to invert the number.
	%percent = 1 - %dmgPer;
	
	if(%percent > 0)
	{
		%newPercent = %percent * 100;
		
		if(%healthStr $= "")
		{
			HUD_HealthBarVehicleTextHP.setVisible($Pref::HealthBar::ShowNumbers);
			HUD_HealthBarVehicleTextHP.setText("<just:center>" @ mFloor(%newPercent) @ "%");
		}
		else
		{
			if(%healthStr $= "I")
			{
				HUD_HealthBarVehicleTextHP.setText("<just:center>INVINCIBLE");
				HUD_HealthBarVehicleTextHP.setVisible($Pref::HealthBar::ShowNumbers);
			}
			else
			{
				HUD_HealthBarVehicleTextHP.setVisible($Pref::HealthBar::ShowNumbers);
				HUD_HealthBarVehicleTextHP.setText("<just:center>" @ mFloor(firstWord(%healthStr)) SPC "/" SPC mFloor(getWord(%healthStr, 1)));
			}
		}

		HUD_HealthMeterVehicle.setPercent(%newPercent, (%healthStr $= "I"));
	}

	else
	{
		//As does the energy bar, if you are killed the bar goes away.
		%gui.setVisible(false);
		HUD_HealthBarVehicleTextHP.setVisible(false);
	}
}

package Healthbar_Client
{
	function disconnectedCleanup(%a)
	{
		HUD_HealthBar.setVisible(false);
		HUD_HealthBarTextHP.setVisible(false);
		HUD_HealthMeter.setPercent(100);

		HUD_HealthBarVehicle.setVisible(false);
		HUD_HealthBarVehicleTextHP.setVisible(false);
		HUD_HealthMeterVehicle.setPercent(100);
		
		return parent::disconnectedCleanup(%a);
	}
	
	function clientCmdShowEnergyBar(%val)
	{
		if(%val)
		{
			HUD_HealthBarContainer.position = getWord(HUD_HealthBarContainer.position,0) SPC 17;
		}
		else
		{
			HUD_HealthBarContainer.position = getWord(HUD_HealthBarContainer.position,0) SPC 6;
		}
		
		return parent::clientCmdShowEnergyBar(%val);
	}
	
	function optionsDlg::onSleep(%this)
	{
		parent::onSleep(%this);
		
		if(OptAdvHP.getValue() != $Pref::HealthBar::ShowNumbers)
		{
			$Pref::HealthBar::ShowNumbers = OptAdvHP.getValue();
			toggleHealthBarNumbers();
		}
	}
};
deactivatePackage("Healthbar_Client");
activatePackage("Healthbar_Client");

function GuiSwatchCtrl::setPercent(%obj, %percent, %invincible)
{
	%tickObj = %obj.dmgTickObj;

	if(%percent < 0)
		%percent = 0;

	%perc = %percent / 100;
	%obj.percent = %percent;
	%max = getWord(%obj.getGroup().extent - %obj.getGroup().barOffset, 0);
	%max2 = getWord(%obj.extent, 1);
	%main = mClampF(%max / 100 * %percent, 0, %max);

	if(%obj.isHealthBar)
	{
		if(%invincible)
		{
			%color = "0.4 0.4 0.4";
		}

		else
		{
			if(%perc <= 1)
			{
				%color = greenToRed(%perc);
			}

			else
			{
				%color = "1 1 1";
			}
		}

		%obj.extent = %main SPC %max2;
		%obj.setColor(%color SPC "1");

		if(isObject(%tickObj))
		{
			cancel(%tickObj.setDamagePercentTick);
			%tickObj.setDamagePercentTick(%obj);
		}
	}

	else if(%obj.useBarTick)
	{
		%obj.extent = %main SPC %max2;

		if(isObject(%tickObj))
		{
			cancel(%tickObj.setDamagePercentTick);
			%tickObj.setDamagePercentTick(%obj);
		}
	}

	else
	{
		%obj.extent = %main SPC %max2;
	}
}

function GuiSwatchCtrl::setDamagePercentTick(%this, %obj)
{
	if(!isObject(%this))
		return;

	if(!isObject(%obj))
		return;

	cancel(%this.setDamagePercentTick);

	%x = getWord(%this.position, 0);
	%y = getWord(%this.position, 1);

	%health = firstWord(%this.extent);
	%max = getWord(%this.getGroup().extent - %this.getGroup().barOffset, 0);
	%main = firstWord(%obj.extent);

	%this.percent = mFloor(100 / %max * %health);
	%perc = %this.percent;

	if(%main > %max)
		%main = %max;

	if(%main < 0)
		%main = 0;

	%o = mFloor(%health - %main);

	if(%o > 0)
	{
		if(%o > 52)
			%a = -10 * mClampF(%o - 52 / 2, 1, 3);
		else if(%o > 42)
			%a = -6;
		else if(%o > 24)
			%a = -4;
		else if(%o > 5)
			%a = -2;
		else
			%a = -1;
	}

	else
	{
		%this.resize(%x, %y, %main, getWord(%obj.extent, 1));

		return;
	}

	if(%health + %a > %main)
	{
		%take = %health + %a;
		%this.resize(%x, %y, %take, getWord(%obj.extent, 1));
	}

	else
	{
		%this.resize(%x, %y, %main, getWord(%obj.extent, 1));

		return;
	}

	%this.setDamagePercentTick = %this.schedule(50, setDamagePercentTick, %obj);
}

function redToGreen(%a)
{
	%r = 1;
	%g = 0.8; //less aggressive green

	if(%a >= (1/2))
		%g = mAbs(%a - 1) * 2;

	if(%a < (1/2))
		%r = %a * 2;

	return %r SPC %g SPC "0";
}

function greenToRed(%a)
{
	%r = 1;
	%g = 0.8; //less aggressive green

	if(%a >= (1/2))
		%r = mAbs(%a - 1) * 2;

	if(%a < (1/2))
		%g = %a * 2;

	return %r SPC %g SPC "0";
}

function toggleHealthBarNumbers()
{
	if(HUD_HealthBar.isVisible())
	{
		HUD_HealthBarTextHP.setVisible($Pref::HealthBar::ShowNumbers);
	} else {
		HUD_HealthBarTextHP.setVisible(0);
	}
	
	if(HUD_HealthBarVehicle.isVisible())
	{
		HUD_HealthBarVehicleTextHP.setVisible($Pref::HealthBar::ShowNumbers);
	} else {
		HUD_HealthBarVehicleTextHP.setVisible(0);
	}
}

function addHealthBarCheckbox()
{
	new GuiCheckBoxCtrl(OptAdvHP) {
		profile = "GuiCheckBoxProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "303 167";
		extent = "175 25";
		minExtent = "8 8";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "Show Health Bar Numbers";
		groupNum = "-1";
		variable = "$healthBarToggleTemp";
		buttonType = "ToggleButton";
	};
	OptGraphicsPane.add(OptAdvHP);
}

if(!isObject(OptAdvHP)) { addHealthBarCheckbox(); }